'Object.inc

#IF NOT %DEF(%MaxObjects)
    %MaxObjects = 32768 'Times 8 bytes per empty object = 256KB or .25MB
#ENDIF

DECLARE SUB CmnObjCall(poObj AS DWORD, ptpPrm AS DWORD)
MACRO mObjCall(oObj, eCall, tPrm) = CALL DWORD eCall USING CmnObjCall(oObj, tPrm)

FUNCTION ObjectAlloc(plCreateFlag AS LONG, plParam AS DWORD) AS DWORD
    'Declarations
        LOCAL llCount1 AS LONG
        LOCAL llFirst AS LONG
        LOCAL llLast AS LONG
        LOCAL llFound AS LONG
        STATIC llInit AS LONG
        STATIC llaUsed() AS LONG
        STATIC lsaData() AS STRING
        STATIC ltCS AS CRITICAL_SECTION

    'Check for Init, handle DIMs, and handle ltCS
        IF llInit = %False THEN
            llInit = %True
            INITIALIZECRITICALSECTION ltCS
            ENTERCRITICALSECTION ltCS
            REDIM llaUsed(1 TO %MaxObjects)
            REDIM lsaData(1 TO %MaxObjects)
        ELSE
            ENTERCRITICALSECTION ltCS
        END IF

    'Case Destroy Object
        IF plCreateFlag = %False THEN
            IF (plParam > LBOUND(lsaData())) AND (plParam < UBOUND(lsaData())) THEN
                FOR llCount1 = LBOUND(llaUsed()) TO UBOUND(llaUsed())
                    IF STRPTR(lsaData(llCount1)) = plParam THEN
                        llaUsed(llCount1) = %False
                        lsaData(llCount1) = ""
                        EXIT FOR
                    END IF
                NEXT llCount1
            END IF
            GOTO ExitFunction:
        END IF

    'Case Create Object
        'Find empty slot
            llFound = %False
            FOR llCount1 = LBOUND(llaUsed()) TO UBOUND(llaUsed())
                IF llaUsed(llCount1) = %False THEN
                    llFound = llCount1
                    EXIT FOR
                END IF
            NEXT llCount1

        'If no free slots we failed...
            IF llFound = %False THEN GOTO ExitFunction:

        'Setup slot
            IF plParam THEN
                'Mark and create space
                    llaUsed(llFound) = %True
                    lsaData(llFound) = STRING$(plParam, 0)
                    IF ERR THEN GOTO ExitFunction:
                'Return pointer to data
                    FUNCTION = STRPTR(lsaData(llFound))
            ELSE
                'Mark
                    llaUsed(llFound) = %True
                'Return pointer to string
                    FUNCTION = VARPTR(lsaData(llFound))
            END IF
    'Leave ltCS
        ExitFunction:
        LEAVECRITICALSECTION ltCS

END FUNCTION


FUNCTION ObjectAllocString(plCreateFlag AS LONG, psString AS STRING) AS DWORD
    LOCAL lspString AS STRING PTR
    IF plCreateFlag THEN
        lspString = ObjectAlloc(%True, 0)
        IF lspString <> %False THEN @lspString = psString
        FUNCTION = lspString
    ELSE
        ObjectAlloc %False, STRPTR(psString)
    END IF
END FUNCTION


TYPE tObject
    lActive AS LONG
    eConstructor AS DWORD
    eDeconstructor AS DWORD
END TYPE
MACRO oObject = tObject PTR


SUB KillObject(poObj AS DWORD, OPTIONAL ptpPrm AS DWORD)
    'De-Alloc memory
        ObjectAlloc %False, poObj
END SUB


FUNCTION NewObject AS DWORD
    LOCAL ltpObject AS oObject

    'Alloc memory
        ltpObject = ObjectAlloc(%True, SIZEOF(@ltpObject))
        IF ltpObject = %False THEN EXIT FUNCTION

    'Set defaults
        @ltpObject.lActive = %True
        @ltpObject.eConstructor = CODEPTR(NewObject)
        @ltpObject.eDeconstructor = CODEPTR(KillObject)

    'Return pointer
        FUNCTION = ltpObject

END FUNCTION
